SIMPLE_ANIMAL_DEFINITIONS["togen_foot_amy"] = {
  ["goal"] = {W},
  ["stand"] = {A},
  ["walk"] = {B, C, D, E, F, Z+4, H, I}, -- G and J get used for the character select animation.
  ["run"] = {Z+5, K, L, M, N, O, P, Q},
  ["reverse"] = {I, H, Z+4, F, E, D, C, B},
  ["trick"] = {R},
  ["spin"] = {U},
  ["pain"] = {X},
  ["squish"] = {V},
  ["ascend"] = {R},
  ["descend"] = {S, T},
  ["glide"] = {Y},
  ["finished"] = {Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z, Z,
                  Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, Z + 1, -- this
                  Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, Z + 2, -- is
                  Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3, Z + 3} -- overkill
}

function SIMPLE_ANIMAL_HELPERS.isGliding(mobj)
  return mobj.paragliding
end

function SIMPLE_ANIMAL_HOOKS.togen_foot_amy_hook(mobj, sequences)
  if mobj.skin == "togen_foot_amy"
    local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
	
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i)
    end
	
    if (sequences[1] == "goal")
      return
	elseif helpers.isCountdownCharging(mobj)
      return "walk"
    elseif helpers.isAirborne(mobj) and not helpers.isTricking(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj))
      if helpers.isGliding(mobj)
        return "glide"
      elseif helpers.isAscending(mobj)
        return "ascend"
      else
        return "descend"
      end
    elseif(helpers.isWalkSpeed(mobj)) -- Hack to slow down the walking animation at low speeds.
	  local halfspeed = helpers.isWalkSpeedMultiplied(mobj, FRACUNIT/2)
	  local quarterspeed = helpers.isWalkSpeedMultiplied(mobj, FRACUNIT/4)
      if(helpers.isMovingBackward(mobj) and not helpers.isAirborne(mobj))
        if ((not quarterspeed and leveltime%4 < 3) or (quarterspeed and not halfspeed) and leveltime%2 < 1)
          mobj.Simple_AnimaL_timer = $ - 1
        end
        return "reverse"
      elseif ((not quarterspeed and leveltime%4 < 3) or (quarterspeed and not halfspeed) and leveltime%2 < 1)
        mobj.Simple_AnimaL_timer = $ - 1
        return
      end
    elseif helpers.isNoSpeed(mobj) and helpers.isFinished(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj))
      return "finished"
    end
  end
end